Subject: Re: Re: [BUG] net/ppp: A use after free in ppp_unregister_channe

From: Tom Parkin <[email-masked]>
Date: Mon, 15 Mar 2021 09:57:54 +0000

On  Fri, Mar 12, 2021 at 22:47:53 +0800, [email-masked] wrote:
> 
> 
> 
> > -----原始邮件-----
> > 发件人: "Tom Parkin" <[email-masked]>
> > 发送时间: 2021-03-12 18:12:58 (星期五)
> > 收件人: [email-masked]
> > 抄送: [email-masked], [email-masked], [email-masked], [email-masked], [email-masked]
> > 主题: Re: [BUG] net/ppp: A use after free in ppp_unregister_channe
> > 
> > Thanks for the report!
> > 
> > On  Thu, Mar 11, 2021 at 20:34:44 +0800, [email-masked] wrote:
> > > File: drivers/net/ppp/ppp_generic.c
> > > 
> > > In ppp_unregister_channel, pch could be freed in ppp_unbridge_channels()
> > > but after that pch is still in use. Inside the function ppp_unbridge_channels,
> > > if "pchbb == pch" is true and then pch will be freed.
> > 
> > Do you have a way to reproduce a use-after-free scenario?
> > 
> > From static analysis I'm not sure how pch would be freed in
> > ppp_unbridge_channels when called via. ppp_unregister_channel.
> > 
> > In theory (at least!) the caller of ppp_register_net_channel holds 
> > a reference on struct channel which ppp_unregister_channel drops.
> > 
> > Each channel in a bridged pair holds a reference on the other.
> > 
> > Hence on return from ppp_unbridge_channels, the channel should not have
> > been freed (in this code path) because the ppp_register_net_channel
> > reference has not yet been dropped.
> > 
> > Maybe there is an issue with the reference counting or a race of some
> > sort?
> > 
> > > I checked the commit history and found that this problem is introduced from
> > > 4cf476ced45d7 ("ppp: add PPPIOCBRIDGECHAN and PPPIOCUNBRIDGECHAN ioctls").
> > > 
> > > I have no idea about how to generate a suitable patch, sorry.
> 
> This issue was reported by a path-sensitive static analyzer developed by our Lab,
> thus i have not a crash or bug log.

Does the analyzer report the sequence of events that lead to a
possible use-after-free?   Is it starting from the assumption that
ppp_unbridge_channels is called with pch->file.refcnt == 1?

> As the return type of ppp_unbridge_channels() is a int, can we return a value to
> inform caller that the channel is freed?

If ppp_unbridge_channels frees the channel in the
ppp_unregister_channel call path, that implies that
ppp_unregister_channel is called when only the bridge is keeping the
channel alive.  So the caller is attempting to drop a reference it
doesn't in fact have.

It might be preferable to defensively code against that possibility of
course.